=begin
#Phone.com API

#This is a Phone.com api PhoneCom definition

OpenAPI spec version: 1.0.0
Contact: apisupport@phone.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
PhoneCom Codegen version: 2.4.4

=end

require 'uri'

module PhoneComClient
  class ExtensionsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create an individual extension.
    # Create an individual extension. See extension for more details.
    # @param account_id Account ID
    # @param [Hash] opts the optional parameters
    # @option opts [CreateExtensionParams] :data Account Extensions Data
    # @return [ExtensionFull]
    def create_account_extension(account_id, opts = {})
      data, _status_code, _headers = create_account_extension_with_http_info(account_id, opts)
      data
    end

    # Create an individual extension.
    # Create an individual extension. See extension for more details.
    # @param account_id Account ID
    # @param [Hash] opts the optional parameters
    # @option opts [CreateExtensionParams] :data Account Extensions Data
    # @return [Array<(ExtensionFull, Fixnum, Hash)>] ExtensionFull data, response status code and response headers
    def create_account_extension_with_http_info(account_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExtensionsApi.create_account_extension ...'
      end
      # verify the required parameter 'account_id' is set
      if @api_client.config.client_side_validation && account_id.nil?
        fail ArgumentError, "Missing the required parameter 'account_id' when calling ExtensionsApi.create_account_extension"
      end
      # resource path
      local_var_path = '/accounts/{account_id}/extensions'.sub('{' + 'account_id' + '}', account_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(opts[:'data'])
      auth_names = ['apiKey']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ExtensionFull')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExtensionsApi#create_account_extension\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Show details of an individual extension.
    # Show details of an individual extension. See extension for more details.
    # @param account_id Account ID
    # @param extension_id Extension ID
    # @param [Hash] opts the optional parameters
    # @return [ExtensionFull]
    def get_account_extension(account_id, extension_id, opts = {})
      data, _status_code, _headers = get_account_extension_with_http_info(account_id, extension_id, opts)
      data
    end

    # Show details of an individual extension.
    # Show details of an individual extension. See extension for more details.
    # @param account_id Account ID
    # @param extension_id Extension ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(ExtensionFull, Fixnum, Hash)>] ExtensionFull data, response status code and response headers
    def get_account_extension_with_http_info(account_id, extension_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExtensionsApi.get_account_extension ...'
      end
      # verify the required parameter 'account_id' is set
      if @api_client.config.client_side_validation && account_id.nil?
        fail ArgumentError, "Missing the required parameter 'account_id' when calling ExtensionsApi.get_account_extension"
      end
      # verify the required parameter 'extension_id' is set
      if @api_client.config.client_side_validation && extension_id.nil?
        fail ArgumentError, "Missing the required parameter 'extension_id' when calling ExtensionsApi.get_account_extension"
      end
      # resource path
      local_var_path = '/accounts/{account_id}/extensions/{extension_id}'.sub('{' + 'account_id' + '}', account_id.to_s).sub('{' + 'extension_id' + '}', extension_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['apiKey']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ExtensionFull')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExtensionsApi#get_account_extension\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get a list of extensions visible to the authenticated user or client.
    # Get a list of extensions visible to the authenticated user or client. See extension for more details.
    # @param account_id Account ID
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :filters_id ID filter
    # @option opts [Array<String>] :filters_extension Extension filter
    # @option opts [Array<String>] :filters_name Name filter
    # @option opts [String] :sort_id ID sorting
    # @option opts [String] :sort_extension Extension sorting
    # @option opts [String] :sort_name Name sorting
    # @option opts [Integer] :limit Max results
    # @option opts [Integer] :offset Results to skip
    # @option opts [String] :fields Field set
    # @return [ListExtensions]
    def list_account_extensions(account_id, opts = {})
      data, _status_code, _headers = list_account_extensions_with_http_info(account_id, opts)
      data
    end

    # Get a list of extensions visible to the authenticated user or client.
    # Get a list of extensions visible to the authenticated user or client. See extension for more details.
    # @param account_id Account ID
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :filters_id ID filter
    # @option opts [Array<String>] :filters_extension Extension filter
    # @option opts [Array<String>] :filters_name Name filter
    # @option opts [String] :sort_id ID sorting
    # @option opts [String] :sort_extension Extension sorting
    # @option opts [String] :sort_name Name sorting
    # @option opts [Integer] :limit Max results
    # @option opts [Integer] :offset Results to skip
    # @option opts [String] :fields Field set
    # @return [Array<(ListExtensions, Fixnum, Hash)>] ListExtensions data, response status code and response headers
    def list_account_extensions_with_http_info(account_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExtensionsApi.list_account_extensions ...'
      end
      # verify the required parameter 'account_id' is set
      if @api_client.config.client_side_validation && account_id.nil?
        fail ArgumentError, "Missing the required parameter 'account_id' when calling ExtensionsApi.list_account_extensions"
      end
      if @api_client.config.client_side_validation && !opts[:'sort_id'].nil? && opts[:'sort_id'] !~ Regexp.new(/asc|desc/)
        fail ArgumentError, "invalid value for 'opts[:\"sort_id\"]' when calling ExtensionsApi.list_account_extensions, must conform to the pattern /asc|desc/."
      end

      if @api_client.config.client_side_validation && !opts[:'sort_extension'].nil? && opts[:'sort_extension'] !~ Regexp.new(/asc|desc/)
        fail ArgumentError, "invalid value for 'opts[:\"sort_extension\"]' when calling ExtensionsApi.list_account_extensions, must conform to the pattern /asc|desc/."
      end

      if @api_client.config.client_side_validation && !opts[:'sort_name'].nil? && opts[:'sort_name'] !~ Regexp.new(/asc|desc/)
        fail ArgumentError, "invalid value for 'opts[:\"sort_name\"]' when calling ExtensionsApi.list_account_extensions, must conform to the pattern /asc|desc/."
      end

      # resource path
      local_var_path = '/accounts/{account_id}/extensions'.sub('{' + 'account_id' + '}', account_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'filters[id]'] = @api_client.build_collection_param(opts[:'filters_id'], :multi) if !opts[:'filters_id'].nil?
      query_params[:'filters[extension]'] = @api_client.build_collection_param(opts[:'filters_extension'], :multi) if !opts[:'filters_extension'].nil?
      query_params[:'filters[name]'] = @api_client.build_collection_param(opts[:'filters_name'], :multi) if !opts[:'filters_name'].nil?
      query_params[:'sort[id]'] = opts[:'sort_id'] if !opts[:'sort_id'].nil?
      query_params[:'sort[extension]'] = opts[:'sort_extension'] if !opts[:'sort_extension'].nil?
      query_params[:'sort[name]'] = opts[:'sort_name'] if !opts[:'sort_name'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['apiKey']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ListExtensions')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExtensionsApi#list_account_extensions\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Replace an individual extension.
    # Replace an individual extension. See extension for more details.
    # @param account_id Account ID
    # @param extension_id Extension ID
    # @param [Hash] opts the optional parameters
    # @option opts [ReplaceExtensionParams] :data Account Extensions Data
    # @return [ExtensionFull]
    def replace_account_extension(account_id, extension_id, opts = {})
      data, _status_code, _headers = replace_account_extension_with_http_info(account_id, extension_id, opts)
      data
    end

    # Replace an individual extension.
    # Replace an individual extension. See extension for more details.
    # @param account_id Account ID
    # @param extension_id Extension ID
    # @param [Hash] opts the optional parameters
    # @option opts [ReplaceExtensionParams] :data Account Extensions Data
    # @return [Array<(ExtensionFull, Fixnum, Hash)>] ExtensionFull data, response status code and response headers
    def replace_account_extension_with_http_info(account_id, extension_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ExtensionsApi.replace_account_extension ...'
      end
      # verify the required parameter 'account_id' is set
      if @api_client.config.client_side_validation && account_id.nil?
        fail ArgumentError, "Missing the required parameter 'account_id' when calling ExtensionsApi.replace_account_extension"
      end
      # verify the required parameter 'extension_id' is set
      if @api_client.config.client_side_validation && extension_id.nil?
        fail ArgumentError, "Missing the required parameter 'extension_id' when calling ExtensionsApi.replace_account_extension"
      end
      # resource path
      local_var_path = '/accounts/{account_id}/extensions/{extension_id}'.sub('{' + 'account_id' + '}', account_id.to_s).sub('{' + 'extension_id' + '}', extension_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(opts[:'data'])
      auth_names = ['apiKey']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ExtensionFull')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ExtensionsApi#replace_account_extension\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
