=begin
#Phone.com API

#This is a Phone.com api PhoneCom definition

OpenAPI spec version: 1.0.0
Contact: apisupport@phone.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
PhoneCom Codegen version: 2.4.4

=end

require 'uri'

module PhoneComClient
  class TrunksApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Add a trunk record with SIP information.
    # Add a trunk record with SIP information. See Account Trunks for more info on the properties.
    # @param account_id Account ID
    # @param data Trunk data
    # @param [Hash] opts the optional parameters
    # @return [TrunkFull]
    def create_account_trunk(account_id, data, opts = {})
      data, _status_code, _headers = create_account_trunk_with_http_info(account_id, data, opts)
      data
    end

    # Add a trunk record with SIP information.
    # Add a trunk record with SIP information. See Account Trunks for more info on the properties.
    # @param account_id Account ID
    # @param data Trunk data
    # @param [Hash] opts the optional parameters
    # @return [Array<(TrunkFull, Fixnum, Hash)>] TrunkFull data, response status code and response headers
    def create_account_trunk_with_http_info(account_id, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TrunksApi.create_account_trunk ...'
      end
      # verify the required parameter 'account_id' is set
      if @api_client.config.client_side_validation && account_id.nil?
        fail ArgumentError, "Missing the required parameter 'account_id' when calling TrunksApi.create_account_trunk"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling TrunksApi.create_account_trunk"
      end
      # resource path
      local_var_path = '/accounts/{account_id}/trunks'.sub('{' + 'account_id' + '}', account_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['apiKey']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'TrunkFull')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TrunksApi#create_account_trunk\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Delete a trunk from account.
    # Delete a trunk from account. See Account Trunks for more info on the properties.
    # @param account_id Account ID
    # @param trunk_id Trunk ID
    # @param [Hash] opts the optional parameters
    # @return [DeleteEntry]
    def delete_account_trunk(account_id, trunk_id, opts = {})
      data, _status_code, _headers = delete_account_trunk_with_http_info(account_id, trunk_id, opts)
      data
    end

    # Delete a trunk from account.
    # Delete a trunk from account. See Account Trunks for more info on the properties.
    # @param account_id Account ID
    # @param trunk_id Trunk ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(DeleteEntry, Fixnum, Hash)>] DeleteEntry data, response status code and response headers
    def delete_account_trunk_with_http_info(account_id, trunk_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TrunksApi.delete_account_trunk ...'
      end
      # verify the required parameter 'account_id' is set
      if @api_client.config.client_side_validation && account_id.nil?
        fail ArgumentError, "Missing the required parameter 'account_id' when calling TrunksApi.delete_account_trunk"
      end
      # verify the required parameter 'trunk_id' is set
      if @api_client.config.client_side_validation && trunk_id.nil?
        fail ArgumentError, "Missing the required parameter 'trunk_id' when calling TrunksApi.delete_account_trunk"
      end
      # resource path
      local_var_path = '/accounts/{account_id}/trunks/{trunk_id}'.sub('{' + 'account_id' + '}', account_id.to_s).sub('{' + 'trunk_id' + '}', trunk_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['apiKey']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'DeleteEntry')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TrunksApi#delete_account_trunk\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Show details of an individual trunk.
    # Show details of an individual trunk. See Account Trunks for more info on the properties.
    # @param account_id Account ID
    # @param trunk_id Trunk ID
    # @param [Hash] opts the optional parameters
    # @return [TrunkFull]
    def get_account_trunk(account_id, trunk_id, opts = {})
      data, _status_code, _headers = get_account_trunk_with_http_info(account_id, trunk_id, opts)
      data
    end

    # Show details of an individual trunk.
    # Show details of an individual trunk. See Account Trunks for more info on the properties.
    # @param account_id Account ID
    # @param trunk_id Trunk ID
    # @param [Hash] opts the optional parameters
    # @return [Array<(TrunkFull, Fixnum, Hash)>] TrunkFull data, response status code and response headers
    def get_account_trunk_with_http_info(account_id, trunk_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TrunksApi.get_account_trunk ...'
      end
      # verify the required parameter 'account_id' is set
      if @api_client.config.client_side_validation && account_id.nil?
        fail ArgumentError, "Missing the required parameter 'account_id' when calling TrunksApi.get_account_trunk"
      end
      # verify the required parameter 'trunk_id' is set
      if @api_client.config.client_side_validation && trunk_id.nil?
        fail ArgumentError, "Missing the required parameter 'trunk_id' when calling TrunksApi.get_account_trunk"
      end
      # resource path
      local_var_path = '/accounts/{account_id}/trunks/{trunk_id}'.sub('{' + 'account_id' + '}', account_id.to_s).sub('{' + 'trunk_id' + '}', trunk_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['apiKey']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'TrunkFull')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TrunksApi#get_account_trunk\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Get a list of trunks for an account.
    # Get a list of trunks for an account. See Account Trunks for more info on the properties.
    # @param account_id Account ID
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :filters_id ID filter
    # @option opts [Array<String>] :filters_name Name filter
    # @option opts [String] :sort_id ID sorting
    # @option opts [String] :sort_name Name sorting
    # @option opts [Integer] :limit Max results
    # @option opts [Integer] :offset Results to skip
    # @option opts [String] :fields Field set
    # @return [ListTrunks]
    def list_account_trunks(account_id, opts = {})
      data, _status_code, _headers = list_account_trunks_with_http_info(account_id, opts)
      data
    end

    # Get a list of trunks for an account.
    # Get a list of trunks for an account. See Account Trunks for more info on the properties.
    # @param account_id Account ID
    # @param [Hash] opts the optional parameters
    # @option opts [Array<String>] :filters_id ID filter
    # @option opts [Array<String>] :filters_name Name filter
    # @option opts [String] :sort_id ID sorting
    # @option opts [String] :sort_name Name sorting
    # @option opts [Integer] :limit Max results
    # @option opts [Integer] :offset Results to skip
    # @option opts [String] :fields Field set
    # @return [Array<(ListTrunks, Fixnum, Hash)>] ListTrunks data, response status code and response headers
    def list_account_trunks_with_http_info(account_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TrunksApi.list_account_trunks ...'
      end
      # verify the required parameter 'account_id' is set
      if @api_client.config.client_side_validation && account_id.nil?
        fail ArgumentError, "Missing the required parameter 'account_id' when calling TrunksApi.list_account_trunks"
      end
      if @api_client.config.client_side_validation && !opts[:'sort_id'].nil? && opts[:'sort_id'] !~ Regexp.new(/asc|desc/)
        fail ArgumentError, "invalid value for 'opts[:\"sort_id\"]' when calling TrunksApi.list_account_trunks, must conform to the pattern /asc|desc/."
      end

      if @api_client.config.client_side_validation && !opts[:'sort_name'].nil? && opts[:'sort_name'] !~ Regexp.new(/asc|desc/)
        fail ArgumentError, "invalid value for 'opts[:\"sort_name\"]' when calling TrunksApi.list_account_trunks, must conform to the pattern /asc|desc/."
      end

      # resource path
      local_var_path = '/accounts/{account_id}/trunks'.sub('{' + 'account_id' + '}', account_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'filters[id]'] = @api_client.build_collection_param(opts[:'filters_id'], :multi) if !opts[:'filters_id'].nil?
      query_params[:'filters[name]'] = @api_client.build_collection_param(opts[:'filters_name'], :multi) if !opts[:'filters_name'].nil?
      query_params[:'sort[id]'] = opts[:'sort_id'] if !opts[:'sort_id'].nil?
      query_params[:'sort[name]'] = opts[:'sort_name'] if !opts[:'sort_name'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['apiKey']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'ListTrunks')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TrunksApi#list_account_trunks\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
    # Replace parameters in a trunk.
    # Replace parameters in a trunk. See Account Trunks for more info on the properties.
    # @param account_id Account ID
    # @param trunk_id Trunk ID
    # @param data Trunk data
    # @param [Hash] opts the optional parameters
    # @return [TrunkFull]
    def replace_account_trunk(account_id, trunk_id, data, opts = {})
      data, _status_code, _headers = replace_account_trunk_with_http_info(account_id, trunk_id, data, opts)
      data
    end

    # Replace parameters in a trunk.
    # Replace parameters in a trunk. See Account Trunks for more info on the properties.
    # @param account_id Account ID
    # @param trunk_id Trunk ID
    # @param data Trunk data
    # @param [Hash] opts the optional parameters
    # @return [Array<(TrunkFull, Fixnum, Hash)>] TrunkFull data, response status code and response headers
    def replace_account_trunk_with_http_info(account_id, trunk_id, data, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: TrunksApi.replace_account_trunk ...'
      end
      # verify the required parameter 'account_id' is set
      if @api_client.config.client_side_validation && account_id.nil?
        fail ArgumentError, "Missing the required parameter 'account_id' when calling TrunksApi.replace_account_trunk"
      end
      # verify the required parameter 'trunk_id' is set
      if @api_client.config.client_side_validation && trunk_id.nil?
        fail ArgumentError, "Missing the required parameter 'trunk_id' when calling TrunksApi.replace_account_trunk"
      end
      # verify the required parameter 'data' is set
      if @api_client.config.client_side_validation && data.nil?
        fail ArgumentError, "Missing the required parameter 'data' when calling TrunksApi.replace_account_trunk"
      end
      # resource path
      local_var_path = '/accounts/{account_id}/trunks/{trunk_id}'.sub('{' + 'account_id' + '}', account_id.to_s).sub('{' + 'trunk_id' + '}', trunk_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(data)
      auth_names = ['apiKey']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'TrunkFull')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: TrunksApi#replace_account_trunk\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
