=begin
#Phone.com API

#This is a Phone.com api PhoneCom definition

OpenAPI spec version: 1.0.0
Contact: apisupport@phone.com
Generated by: https://github.com/swagger-api/swagger-codegen.git
PhoneCom Codegen version: 2.4.4

=end

require 'date'

module PhoneComClient
  # Filter Object. Optional. See below for details.
  class RuleSetAction
    # Required.
    attr_accessor :action

    # Extension that this action refers to. Output is an Extension Summary Object. Input must be an Extension Lookup Object. Required.
    attr_accessor :extension

    # This action is for forwarding calls to any number of extensions or phone numbers. The forwarding is handled in parallel, meaning that all phone numbers and/or extensions will ring simultaneously. When the call is answered by any single phone number or extension, ringing will stop for all of them. Subsequent actions in this rule set will be performed if the call is not answered before the timeout period is reached, or if it is forwarded to an extension that has its own route and that route does not result in any actions that disconnect the call or take over call handling.
    attr_accessor :items

    # Seconds that our routing engine should wait until moving on. Optional. Must be an integer between 5 and 90. Default is 5 seconds.
    attr_accessor :timeout

    # Hold Music to be played while callers are waiting. Output is a Media Summary Object. Input must be a Media Lookup Object. Optional. Must refer to a media recording that has is_hold_music set to TRUE. Default is to play a standard ring tone.
    attr_accessor :hold_music

    # Greeting that this action refers to. Output is a Media Summary Object. Input must be a Media Lookup Object. Required. Must refer to a media recording that has is_hold_music set to FALSE.
    attr_accessor :greeting

    # Required. Seconds that the caller should be placed on hold before being moved onto the next action. Must be an integer between 1 and 60 seconds.
    attr_accessor :duration

    # Menu that this action refers to. Required. Output is a Menu Summary Object. Input must be a Menu Lookup Object.
    attr_accessor :menu

    # Queue that this action refers to. Required. Output is a Queue Summary Object. Input must be a Queue Lookup Object.
    attr_accessor :queue

    # Trunk that this action refers to. Required. Output is a Trunk Summary Object. Input must be a Trunk Lookup Object.
    attr_accessor :trunk

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'action' => :'action',
        :'extension' => :'extension',
        :'items' => :'items',
        :'timeout' => :'timeout',
        :'hold_music' => :'hold_music',
        :'greeting' => :'greeting',
        :'duration' => :'duration',
        :'menu' => :'menu',
        :'queue' => :'queue',
        :'trunk' => :'trunk'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'action' => :'String',
        :'extension' => :'ExtensionSummary',
        :'items' => :'Array<RuleSetForwardItem>',
        :'timeout' => :'Integer',
        :'hold_music' => :'MediaSummary',
        :'greeting' => :'MediaSummary',
        :'duration' => :'Integer',
        :'menu' => :'MenuSummary',
        :'queue' => :'QueueSummary',
        :'trunk' => :'TrunkSummary'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h| h[k.to_sym] = v }

      if attributes.has_key?(:'action')
        self.action = attributes[:'action']
      end

      if attributes.has_key?(:'extension')
        self.extension = attributes[:'extension']
      end

      if attributes.has_key?(:'items')
        if (value = attributes[:'items']).is_a?(Array)
          self.items = value
        end
      end

      if attributes.has_key?(:'timeout')
        self.timeout = attributes[:'timeout']
      end

      if attributes.has_key?(:'hold_music')
        self.hold_music = attributes[:'hold_music']
      end

      if attributes.has_key?(:'greeting')
        self.greeting = attributes[:'greeting']
      end

      if attributes.has_key?(:'duration')
        self.duration = attributes[:'duration']
      end

      if attributes.has_key?(:'menu')
        self.menu = attributes[:'menu']
      end

      if attributes.has_key?(:'queue')
        self.queue = attributes[:'queue']
      end

      if attributes.has_key?(:'trunk')
        self.trunk = attributes[:'trunk']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@action.nil? && @action !~ Regexp.new(/directory|disconnect|fax|forward|greeting|hold|menu|queue|trunk|voicemail/)
        invalid_properties.push('invalid value for "action", must conform to the pattern /directory|disconnect|fax|forward|greeting|hold|menu|queue|trunk|voicemail/.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@action.nil? && @action !~ Regexp.new(/directory|disconnect|fax|forward|greeting|hold|menu|queue|trunk|voicemail/)
      true
    end

    # Custom attribute writer method with validation
    # @param [Object] action Value to be assigned
    def action=(action)
      if !action.nil? && action !~ Regexp.new(/directory|disconnect|fax|forward|greeting|hold|menu|queue|trunk|voicemail/)
        fail ArgumentError, 'invalid value for "action", must conform to the pattern /directory|disconnect|fax|forward|greeting|hold|menu|queue|trunk|voicemail/.'
      end

      @action = action
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          action == o.action &&
          extension == o.extension &&
          items == o.items &&
          timeout == o.timeout &&
          hold_music == o.hold_music &&
          greeting == o.greeting &&
          duration == o.duration &&
          menu == o.menu &&
          queue == o.queue &&
          trunk == o.trunk
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [action, extension, items, timeout, hold_music, greeting, duration, menu, queue, trunk].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = PhoneComClient.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
